''Chris Joens
''Research project

CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000
  LCD_Pin       = 0                    'The LCD is connected to pin A0.
  LCD_Baud      = 19_200               'Baud
  LCD_Lines     = 4                    'The number of lines on this LCD
  Off           = 0
  On            = 1
  CRC_BYTE_Count  = 4                   'Total Number BYTES in polynomial CRC packet
  TXpin        = 2                   'Connected to Parallax Transmiter
  RXpin        = 1                  'Connected to Parallax Reciver
  FIFOBufferSize = 16
  Baud          = 9600          'Set Mode for Open Collector and ignore TX echo
  TRmode        = 5             
  
OBJ
  Debug:  "FullDuplexSerialPlus"
  LCD:    "debug_lcd"                        'Creates the object LCD from "debug_lcd"
  CRC:    "CRC_polynomial_oneshot"         
VAR
  byte  StringBuffer[FIFOBufferSize],Null
  long  ErrorCounter,ValidCounter

 
PUB Start (_Length)  
    Debug.start(RXpin, TXpin, %1100, Baud)               '' Initialize serial as:
                                '' mode bit 0 = invert rx
                                '' mode bit 1 = invert tx
                                '' mode bit 2 = open-drain/source tx
                                '' mode bit 3 = ignore tx echo on rx

  Length                      := _Length
  Polynomial                  := CRC#CRC_16_IBM           'CRC polynomial value
  if lcd.init(LCD_PIN, LCD_BAUD, LCD_LINES)             ' start lcd
      lcd.cursor(0)                                       ' cursor off
      lcd.backLight(true)                                 ' backlight on (if available)
      lcd.custom(0, @Bullet)                              ' create custom character 0
      lcd.cls                                             ' clear the lcd
      lcd.str(string(" WSN", 13))
      lcd.putc(0)                                         ' display custom bullet character
      lcd.str(string("Error", 13))
      lcd.putc(0)
      lcd.str(string("Data", 13)) 
      lcd.putc(0)
      lcd.str(string("Sensor"))
     
     waitcnt(clkfreq + cnt)
PUB Count| value, counter
     lcd.gotoxy(10, 0)      
     lcd.Str(@MyString)
     lcd.Dec(counter++)
PUB Send
    Set_TX_Mode
    Calculate_CRC(@TX_Address)
    Send_Sync(5)
    Send_DataBuffer

PUB Receive
    Set_RX_Mode
    repeat while SyncDetect == 0 
    If Buffer_Index == 0
       Receive_DataBuffer0 
       Calculate_CRC(@RX_Address0)
    else   
       Receive_DataBuffer1
       Calculate_CRC(@RX_Address1)
    If CRC_Valid == 1
       Buffer_Index := 1 - Buffer_Index
 
PUB Calculate_CRC(Data_Address)
    DataOffset := Data_Address - @CRCvalue
    CRC.Start(@Polynomial)                              '' Get CRC value
    repeat until CRC_ready == 1                         '' Only necessary for large data
    
PUB Set_TX_Mode
    dira[TRmode]~~                                      '' Set mode to Transmit
    outa[TRmode]~~                                      '' Set mode to Transmit

PUB Set_RX_Mode
    dira[TRmode]~~                                      '' Set mode to Receive
    outa[TRmode]~                                       '' Set mode to Receive

PUB Send_Sync(Num)
    repeat Num
      Debug.str(string("!"))
    Debug.str(string("S"))

PUB SyncDetect
    if Debug.rx == "S"
       Result := 1
       Light_LEDs       
    else
       Result := 0
       Kill_LEDs
   
PUB Send_DataBuffer|Index
    repeat Index from 0 to Length - 1
      Debug.tx(TX_Address[Index])
    repeat Index from 0 to CRC_BYTE_Count - 1  
      Debug.tx(CRCbyte[Index])

PUB Receive_DataBuffer0|Index           
    repeat Index from 0 to Length -1
      RX_Address0[Index] := Debug.rx 
    repeat Index from 0 to CRC_BYTE_Count - 1  
      RX_CRC_byte[Index] := Debug.rx

PUB Receive_DataBuffer1|Index           
    repeat Index from 0 to Length -1
      RX_Address1[Index] := Debug.rx 
    repeat Index from 0 to CRC_BYTE_Count - 1  
      RX_CRC_byte[Index] := Debug.rx

PUB CRC_Valid
    If CRCvalue == RX_CRC_value
       Result := 1
    else
       Result := 0

PUB GetRX(Index)
    If Buffer_Index == 0
       Result := RX_Address1[Index]
    else   
       Result := RX_Address0[Index]
       
PUB PutTX(Index,BYTEValue)
    TX_Address[Index] := BYTEValue

PUB Read_RX_CRC
    Result := RX_CRC_value    

PUB Read_Local_CRC
    Result := CRCvalue

PUB Light_LEDs
    dira[16..23]~~        
    outa[16..23]~~

PUB Kill_LEDs
    dira[16..23]~~        
    outa[16..23]~

DAT
  Bullet          byte     $00, $04, $0E, $1F, $0E, $04, $00, $00
  MyString        byte     "Run CNT", 0
  testStr         byte     " I Made it" ,0
  BlankLine       byte      Debug#CR, Debug#CR, 0

'------------------------------------------------------------------------------------
'                         Data variables below here must be contiguous
'------------------------------------------------------------------------------------
CRC_ready     long      0     '<-- Flag set by the CRC engine to indicate if the CRC is ready

Polynomial    long      0
Length        long      0

CRCvalue      long            '<-- purposefully left blank so that CRCvalue is aliased as a LONG, and CRCbyte is Aliased as a BYTE
CRCbyte       byte      0     '    with the SAME address.  This allows easy access to the BYTES within the Seed LONG variable.  
              byte      0
              byte      0
              byte      0

DataOffset    long      0
'------------------------------------------------------------------------------------
'                        Data variables above here must be contiguous
'------------------------------------------------------------------------------------

Buffer_Index  long      0

RX_CRC_value  long
RX_CRC_byte   byte      0
              byte      0
              byte      0
              byte      0

TX_CRC_value  long
TX_CRC_byte   byte      0
              byte      0
              byte      0
              byte      0

RX_Address0           {{                           512 Bytes                           }}
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  

RX_Address1           {{                           512 Bytes                           }}
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  

TX_Address            {{                           512 Bytes                           }}
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
              byte      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                  
